--- linux-2.4.3+patched/net/ipv6/addrconf.c.orig	Wed Apr 25 21:56:01 2001
+++ linux-2.4.3+patched/net/ipv6/addrconf.c	Wed Apr 25 21:58:08 2001
@@ -283,8 +283,6 @@
 	if ((idev = __in6_dev_get(dev)) == NULL) {
 		if ((idev = ipv6_add_dev(dev)) == NULL)
 			return NULL;
-		if (dev->flags&IFF_UP)
-			ipv6_mc_up(idev);
 	}
 	return idev;
 }
@@ -1181,6 +1179,8 @@
 		return;
 	}
 
+	ipv6_mc_up(idev);
+
 	ifp = ipv6_add_addr(idev, &addr, 128, IFA_HOST, IFA_F_PERMANENT);
 	if (ifp) {
 		spin_lock_bh(&ifp->lock);
@@ -1220,6 +1220,8 @@
 	if (idev == NULL)
 		return;
 
+	ipv6_mc_up(idev);
+
 #ifdef CONFIG_IPV6_EUI64
 	memset(&addr, 0, sizeof(struct in6_addr));
 
@@ -1258,6 +1260,8 @@
 		printk(KERN_DEBUG "init sit: add_dev failed\n");
 		return;
 	}
+
+	ipv6_mc_up(idev);
 
 	sit_add_v4_addrs(idev);
 
